﻿// Fill out your copyright notice in the Description page of Project Settings.


#include "GOAPAction.h"

bool UGOAPAction::CheckPreConditions(TMap<FString, int32> WorldState)
{
	for (TPair<FString, int32> PreCondition : PreConditions)
	{
		if (WorldState.Contains(PreCondition.Key))
		{
			if (WorldState[PreCondition.Key] != PreCondition.Value) return false;
		}
	}
	return true;
}

TMap<FString, int32> UGOAPAction::ApplyEffects(TMap<FString, int32> WorldState)
{
	for (TPair<FString, int32> Effect : Effects)
	{
		if (WorldState.Contains(Effect.Key))
		{
			WorldState[Effect.Key] = Effect.Value;
		}
		else
		{
			WorldState.Add(Effect.Key, Effect.Value);
		}
	}
	return WorldState;
}
