# COMP250 Project Proposal

## Computing Artifact Outline

The computing artifact I am proposing is a combat artificial intelligence attached to an enemy non-player character for a small turn based strategy game with the focus of resource management and combo building. In this game you have a limited set of resources that can be used to build combos to attack an opponent and defend yourself. Combos vary in resource costs and which resource is required for it to be cast. To win you must defeat the opponent by reducing their health to 0.
The combat artificial intelligence must be able to find the optimal set of combos and actions to defeat their opponent.

## Artifact Specialism

This computing artifact is suitable for the specified specialism of Artificial Intelligence as it falls under the specified contract of non-player character behaviour. The computing artifact will apply a goal-directed behaviour system. The combat artificial intelligence will be using the Goal Oriented Action Planning (GOAP) (Suyikno and Setiawan 2019) artificial intelligence to guide and action the resource management and combo build to aim for the goal of eliminating the player. GOAP is a form of artificial intelligence planning system that is used in computer games to generate intelligent behaviour for non-player characters (NPCs). It operates by identifying a goal state and a set of actions that can be taken to achieve the goal, and then use search algorithms such as Depth First Search (DFS) or Breadth First Search (BFS) against a tree to find the most cost effective plan that will achieve the goal by executing the available actions in the generated order. (Brent Owens 2014)

## Potential Applications

A combat artificial intelligence can use GOAP to become more adaptable and intelligent in its decision-making, which makes it a useful tool for game designers who want to develop entertaining and challenging gameplay. Combat can become more strategic and sophisticated with the help of GOAP providing players with a more immersive gaming experience.

This artificial intelligence is not only limited to resource management and combo-building features if more parameters are included in the GOAP system for example weather conditions, or stealth conditions. The artificial intelligence can take these into account when deciding what actions to take. This can be used in a stealth game where the artificial intelligence must sneak past enemies or in a survival game where the artificial intelligence must avoid the weather conditions. (Mitchell 2015)

## Existing Solutions

Current existing solutions using the Goal Oriented Action Planning artificial intelligence is the game F.E.A.R. (2005) (Monolith Productions 2005).
GOAP was originally designed for F.E.A.R, an example of actions to complete their goals that were included in their artificial intelligence:

* Moving into a position in the world.
* Playing an animation.
* Interacting with a smart object (an item in the world that artificial intelligence characters can interact with) (AIandGames 2020)

Another example of a project using the Goal Oriented Action Planning artificial intelligence is a Third Year Undergraduate Dissertation Project called StarPlanner by Panagiotis Peikidis to play the game StarCraft. (Peikidis 2010)

Both of these projects use the Goal Oriented Action Planning artificial intelligence to plan and execute actions to achieve a goal or goals. The main goal in F.E.A.R. is to kill the player and the goal in StarPlanner is to win the game. These projects convey the effectiveness of the Goal Oriented Action Planning artificial intelligence in a game environment in a combat setting.

## Development Plan & Scope

The development plan for this computing artifact will consist of 6 weeks of development split into 5 milestones. The first milestone will be to research and understand the Goal Oriented Action Planning artificial intelligence and how it can be applied to a combat artificial intelligence and to decide which search algorithm will be the most optimal for this specific case. The second milestone will be to build the game. The third milestone will be to implement the resource management and combo-building features into the combat artificial intelligence including the costs of each action. The fourth milestone will be to test the combat artificial intelligence and make any necessary changes by adjusting the costs. The fifth milestone will be to polish the combat artificial intelligence, make any final changes and bug fixes.

## Practiced Based Research

This constitutes as practice based research as it is a project in which will analyze artificial intelligence systems and apply them. In this case finite state machines and behaviour trees. The project will compare the feasibility of these systems and the effectiveness of the Goal Oriented Action Planning artificial intelligence and apply these techniques in a game environment.

*Word Count: 786*
## References

AIANDGAMES. 2020. ÔÇÿBuilding the AI of F.E.A.R. With Goal Oriented Action Planning, AI and GamesÔÇÖ. AI and Games [online]. Available at: https://www.aiandgames.com/2020/05/06/ai-101-goap-fear/.

BRENT OWENS, Brent. 2014. ÔÇÿGoal Oriented Action Planning for a Smarter AIÔÇÖ. Game Development Envato Tuts+ [online]. Available at: https://gamedevelopment.tutsplus.com/tutorials/goal-oriented-action-planning-for-a-smarter-ai--cms-20793.

MITCHELL, Jared. 2015. ÔÇÿGoal-Oriented Action Planning ResearchÔÇÖ. Jared Mitchell [online]. Available at: https://jaredemitchell.com/goal-oriented-action-planning-research/.

MONOLITH PRODUCTIONS. 2005. ÔÇÿF.E.A.R.ÔÇÖ.

PEIKIDIS, Panagiotis. 2010. ÔÇÿPanagiotis Peikidis - 3rd Year ProjectÔÇÖ. pekalicious.github.io [online]. Available at: https://pekalicious.github.io/StarPlanner/ [accessed 5 Feb 2023].

SUYIKNO, D A and A SETIAWAN. 2019. ÔÇÿFeasible NPC Hiding Behaviour Using Goal Oriented Action Planning in Case of HideandSeek 3D Game SimulationÔÇÖ. In 2019 Fourth International Conference on Informatics and Computing (ICIC). 1ÔÇô6.

